-- **************************************************************************
-- * TitanGathered.lua - VERSION 4.0.0.30000
-- **************************************************************************
-- * by Medyn @ Radek Roza / Czech Rep.
-- * An addon for World of Warcraft that track materials and tradeitems
-- * in bank and bag and shows all count information in Titan panel tooltip.
-- *
-- * Credits: Please post bug to bajt@volny.cz
-- *          look to www.rrsoft.cz/titan-gathered.html for new update and releases.
-- **************************************************************************

-- ******************************** Constants *******************************
TITAN_ORE_ID = "Ore";
TITAN_ORE_PLAYER_CLASS = "";
local p, TITAN_ORE_PLAYER_CLASS = UnitClass("player");


-- **************************************************************************
-- NAME : TitanPanelOreButton_OnLoad()
-- DESC : Registers the add on upon it loading
-- **************************************************************************
function TitanPanelOreButton_OnLoad(self)
	local tooltipAboutText;

    local function TitanPanelOre_SlashCommand(msg)
      local cmd,var = strsplit(' ', msg or "")
      if cmd then
        TitanPanelOre_addLootItem(cmd);
      elseif cmd == "reset" then
        TgFocusFrame_Reset();
      else
        TitanPanelOre_PrintInfo();
      end
    end

--  SlashCmdList["ADDLOOT"] = function(msg) looter:show() end
--	SLASH_ADDLOOT1 = "/addloot"
--  SlashCmdList["ADDLOOT"] = TitanPanelOre_SlashCommand;
--	SLASH_ADDLOOT1 = "/addloot"
		
	SLASH_TOHISTORY1 = "/tgh"
	SLASH_TPHISTORY2 = "/tghistory"
	SlashCmdList["TOHISTORY"] = function(msg) TitanPanelOre_ShowHistory() end

	SLASH_TGRELOAD1 = "/tgreload"
    SlashCmdList["TGRELOAD"] = function(msg) ReloadUI() end
	
	SLASH_TOBANK1 = "/tgb"
	SLASH_TOBANK2 = "/tgbank"
	SlashCmdList["TOBANK"] = function(msg) TitanPanelOre_ShowBank() end

	echo(TITAN_ORE_LOCAL_NAME.." "..TITAN_ORE_VERSION.." loaded!");

	tooltipAboutText = "|cffff8020"..TITAN_ORE_LOCAL_NAME.." "..TitanUtils_GetGreenText(TITAN_ORE_VERSION).."\n";

	self.registry = {
		id = TITAN_ORE_ID,
		version = TITAN_ORE_VERSION,
		menuText = TITAN_ORE_LOCAL_NAME,
		buttonTextFunction = "TitanPanelOreButton_GetButtonText",
		tooltipTitle = tooltipAboutText,
		category = "Information",
    	tooltipTextFunction = "TitanPanelOreButton_GetTooltipText",
		icon = "Interface\\Addons\\TitanGathered\\Artwork\\TitanOre",
		iconWidth = 16,
		updateType = TITAN_PANEL_UPDATE_TOOLTIP,
		savedVariables = {
			ShowIcon = 1,
			ShowLabelText = 1,
			ShowColoredText = 1,
			ShowInfoTooltip = 1,
			ShowZerro = 1,
			ShowBankItems = 1,
			ExcludeZero = 1,
			ShowSkills = 1,
			ShowSecSkills = 1,
			ShowOre = 1,
			ShowBar = 1,
			ShowStone = 1,
			ShowGem = 1,
			ShowLeather = 1,
			ShowScale = 1,
			ShowHide = 1,
			ShowCloth = 1,
			ShowHerb = 1,
			ShowEssence = 1,
			ShowMisc = 1,
			ShowPmat = 1,
			ShowPoison = 1,
			ShowBandage = 1,
			ShowInscriptInk = 1,
			ShowInscriptPigment = 1,
			ShowCooking = 1,
			Debugmode = 1,
			displayitems = {},
			itemsHistory = {},
			bankHistory = {},
			clearItems = {},
		}
	};
		self:RegisterEvent("PLAYER_ENTERING_WORLD");
		self:RegisterEvent("PLAYER_LEAVING_WORLD");
		self:RegisterEvent("LOOT_OPENED");
		self:RegisterEvent("BANKFRAME_OPENED");
		self:RegisterEvent("BANKFRAME_CLOSED");
end

-- Bouton
function TitanPanelOreButton_GetButtonText(self)

	local txtTitanTitle = " ";
	
	return TITAN_ORE_LOCAL_NAME, txtTitanTitle;
end

-- Tooltip
function TitanPanelOreButton_GetTooltipText(self)
	local tooltipText = "";
	
	local i,e,cat,short,v_count;
	local val=0;
	
	local p, playerClass = UnitClass("player");
	
	local nextText="";
	
	local v_color=TITAN_ORE_GOLD;
	
	local skill_mine = TitanPanelOre_GetSkillLevel("Mining");
	local skill_herb = TitanPanelOre_GetSkillLevel("Herbalism");
	local skill_skin = TitanPanelOre_GetSkillLevel("Skinning");
	local skill_ench = TitanPanelOre_GetSkillLevel("Enchanting");
	local skill_cook = TitanPanelOre_GetSkillLevel("Cooking");

	local skills = {};

	skills["Mining"] = TitanPanelOre_GetSkillLevel("Mining");
	skills["Herbalism"] = TitanPanelOre_GetSkillLevel("Herbalism");
	skills["Skinning"] = TitanPanelOre_GetSkillLevel("Skinning");
	skills["Enchanting"] = TitanPanelOre_GetSkillLevel("Enchanting");
	skills["First Aid"] = TitanPanelOre_GetSkillLevel("First Aid");
	skills["Poisons"] = TitanPanelOre_GetSkillLevel("Poisons");
	skills["Cooking"] = TitanPanelOre_GetSkillLevel("Cooking");
	
	local nextText="";
	local val  = 1;
	local prof = 0;

	if ( not TitanGetVar(TITAN_ORE_ID, "ShowSkills")) then
	    local numskills = GetNumSkillLines();
	    for i=1,numskills do
	        
	    	local skillname, isHeader, _, skillrank,_,_,skillmax = GetSkillLineInfo(i);

	        if ( isHeader ) then
	        	prof = prof + 1;
	       	else
		        if (prof == 2 and skillmax > 1) then
					v_color = TitanPanelOre_GetSkillRankColor(skillrank,skillmax);
	    	    	nextText = nextText..v_color..skillname..":\t"..skillrank..TitanUtils_GetHighlightText("/")..skillmax.."\n";
	    	    end
	       	end
	    end
	
		if (val == 1) then
--			tooltipText = tooltipText.."\n";
			tooltipText = tooltipText..TitanUtils_GetHighlightText(TITAN_ORE_LOCAL_PROFESSIONS.."\n");
			tooltipText = tooltipText..nextText;
		end
	end
	
	local nextText="";
	local val  = 1;
	local prof = 0;

	if ( not TitanGetVar(TITAN_ORE_ID, "ShowSecSkills")) then
	    local numskills = GetNumSkillLines();
	    for i=1,numskills do
	        
	    	local skillname, isHeader, _, skillrank,_,_,skillmax = GetSkillLineInfo(i);

	        if ( isHeader ) then
	        	prof = prof + 1;
	       	else
		        if (prof == 3 and skillmax > 1) then
					v_color = TitanPanelOre_GetSkillRankColor(skillrank,skillmax);
	    	    	nextText = nextText..v_color..skillname..":\t"..skillrank..TitanUtils_GetHighlightText("/")..skillmax.."\n";
	    	    end
	       	end
	    end
	
		if (val == 1) then
--			tooltipText = tooltipText.."\n";
			tooltipText = tooltipText..TitanUtils_GetHighlightText(TITAN_ORE_LOCAL_SEC_PROFESSIONS.."\n");
			tooltipText = tooltipText..nextText;
		end
	end
	
	local nextText="";
	val=0;
	for i,e in pairs(TITAN_ORE_ITEMS) do
		if(e.cat == TITAN_ORE_LOCAL_SHARDS) then

			v_count = TitanPanelOre_CountItem(e.tag);
			b_count = TitanPanelOre_CountItemStoredInBank(e.tag);

			if ( TitanGetVar(TITAN_ORE_ID, "ShowZerro")) then
				if (v_count >0) then
					if (playerClass == "WARLOCK") then
						nextText = nextText..TitanUtils_GetNormalText(e.name)..":\t"..TitanUtils_GetHighlightText(v_count.."\n");
						val=1;
					end
				else
					--val=0;
				end
			else
				if (playerClass == "WARLOCK") then
					nextText = nextText..TitanUtils_GetNormalText(e.name)..":\t"..TitanUtils_GetHighlightText(v_count.."\n");
					val=1;
				end
			end
		end
	end

	if (val == 1) then
		tooltipText = tooltipText.."\n";
		tooltipText = tooltipText..TitanUtils_GetHighlightText(TITAN_ORE_LOCAL_SHARDS.."\n");
		tooltipText = tooltipText..nextText;
	end
	
	
for i,c in pairs(TITAN_ORE_CATEGORIES) do
	local nextText="";
	val=0;

	if (not TitanGetVar(TITAN_ORE_ID, c.save)) then
		for i,e in pairs(TITAN_ORE_ITEMS) do

			if(e.cat == c.name) then

				v_count = TitanPanelOre_CountItem(e.tag);
				b_count = TitanPanelOre_CountItemStoredInBank(e.tag);
				v_color = TitanPanelOre_GetSkilColor(e.skill,skills[c.skillneed]);
				
				if ( TitanGetVar(TITAN_ORE_ID, "ShowZerro")) then
					if (v_count > 0) then
						nextText = nextText..TitanPanelOre_ShowTooltipRow(v_color,e.name,v_count,b_count);
						val=1;
					elseif (b_count >0 and not TitanGetVar(TITAN_ORE_ID, "ExcludeZero") and not TitanGetVar(TITAN_ORE_ID, "ShowBankItems")) then
						nextText = nextText..TitanPanelOre_ShowTooltipRow(v_color,e.name,v_count,b_count);
						val=1;
					end
						--val=0;
					--end
				else
						nextText = nextText..TitanPanelOre_ShowTooltipRow(v_color,e.name,v_count,b_count);
						val=1;
				end
			end
		end
	end

	if (val == 1) then
		tooltipText = tooltipText.."\n";
		tooltipText = tooltipText..TitanUtils_GetHighlightText(c.name.."\n");
		tooltipText = tooltipText..nextText;
	end
	
	
end

	
	return tooltipText;
end

-- Item count function
function TitanPanelOre_CountItem(item_id)
		local nbslots, b, s, t, n;
		local i_count = 0;
		
		for b=0,4 do
			nbslots=GetContainerNumSlots(b);
			for s=0,nbslots do
				local texture, itemCount = GetContainerItemInfo(b, s);

				t = GetContainerItemLink(b, s);
		
				if (t) then

					local bName = GetItemInfo(t);
					local sName = GetItemInfo(item_id);
					
					if(bName==sName) then
						i_count = i_count + itemCount;
					end
				end
			end
		end
		return i_count;
end

-- show tooltip row
function TitanPanelOre_ShowTooltipRow(v_color,e_name,v_count,b_count)
	local t_row = "";
	
	if ( not TitanGetVar(TITAN_ORE_ID, "ShowBankItems")) then
		t_row = v_color..e_name..":\t"..v_count.."/"..b_count.."\n";
	else
		t_row = v_color..e_name..":\t"..v_count.."\n";
	end
	
	return t_row;
end

-- bank item count function
function TitanPanelOre_CountItemStoredInBank(item_id)
		
		local dbb = TitanGetVar(TITAN_ORE_ID, "bankHistory");
		local nbslots, i, e;
		local i_count = 0;
		
	for i,e in pairs(dbb) do

		local _,_, color, id, name = string.find(e.name, "|c(%x+)|Hitem:(%d+):[%d:]+|h%[(.-)%]|h|r");

		if (type(e) == "table") then

			if (id == item_id) then
				i_count = i_count + e.value;
			end
		end
	end
		return i_count;
end

-- Event
function TitanPanelOreButton_OnEvent(self)

	local message;
		if (event == "PLAYER_LEAVING_WORLD") then
			self:UnregisterEvent("BAG_UPDATE");
		end
		if (event == "PLAYER_ENTERING_WORLD") then
			self:RegisterEvent("BAG_UPDATE");
			self:RegisterEvent("LOOT_OPENED");
		end
		if (event == "LOOT_OPENED") then
			TitanPanelOre_loot();
		end
		if (event == "BANKFRAME_OPENED") then
			TitanPanelOre_bankOpen();
		end
		if (event == "BANKFRAME_CLOSED") then
			TitanPanelOre_bankClose();
		end
		if (event == "UPDATE_MOUSEOVER_UNIT") then
			PickingSkill_GameTooltip_SetLootItem();
		end
		TitanPanelButton_UpdateButton(TITAN_ORE_ID);
end

-- Menu
function TitanPanelRightClickMenu_PrepareOreMenu(self)
	local info;
	local i,e,cat,fce,save;

	if ( UIDROPDOWNMENU_MENU_LEVEL == 2 ) then
	
		if ( UIDROPDOWNMENU_MENU_VALUE == TITAN_ORE_LOCAL_SHARDS ) then
			if (TITAN_ORE_PLAYER_CLASS == "WARLOCK") then
				for i,e in pairs(TITAN_ORE_ITEMS) do
					if(e.cat == TITAN_ORE_LOCAL_SHARDS) then
						info = {};
						info.text = e.name;
						info.value = i;
						info.func = TitanPanelOre_SetDisplay;
						info.checked = TitanPanelOreButton_isdisp(i);
						info.keepShownOnClick = 1;
						UIDropDownMenu_AddButton(info,UIDROPDOWNMENU_MENU_LEVEL);
					end
				end
			end
		end

--		for i,c in pairs(TITAN_ORE_CATEGORIES) do
--			if ( UIDROPDOWNMENU_MENU_VALUE == c.name ) then
--	
--				for i,e in pairs(TITAN_ORE_ITEMS) do
--					if(e.cat == c.name) then
--						info = {};
--						info.text = e.name;
--						info.value = i;
--						info.func = TitanPanelOre_SetDisplay;
--						info.checked = TitanPanelOreButton_isdisp(i);
--						info.keepShownOnClick = 1;
--						UIDropDownMenu_AddButton(info,UIDROPDOWNMENU_MENU_LEVEL);
--					end
--				end
--			end
--		end
	
		
		if ( UIDROPDOWNMENU_MENU_VALUE == TITAN_ORE_LOCAL_BANK_ITEMS ) then
			info = {};
			info.text = TITAN_ORE_LOCAL_SHOW_BANK;
			info.func = TitanPanelOreButton_ToggleShowBankItems;
			info.checked = TitanUtils_Toggle(TitanGetVar(TITAN_ORE_ID, "ShowBankItems"));
			info.keepShownOnClick = 1;
			UIDropDownMenu_AddButton(info,UIDROPDOWNMENU_MENU_LEVEL);
		end

		if ( UIDROPDOWNMENU_MENU_VALUE == TITAN_ORE_LOCAL_BANK_ITEMS ) then
			info = {};
			info.text = TITAN_ORE_LOCAL_EXCLUDE_ZERO;
			info.func = TitanPanelOreButton_ToggleEcludeZero;
			info.checked = TitanUtils_Toggle(TitanGetVar(TITAN_ORE_ID, "ExcludeZero"));
			info.keepShownOnClick = 1;
			UIDropDownMenu_AddButton(info,UIDROPDOWNMENU_MENU_LEVEL);
		end
		
		if ( UIDROPDOWNMENU_MENU_VALUE == "DisplayAbout" ) then
			info = {};
			info.text = TITAN_ORE_ABOUT_POPUP_TEXT;
			info.value = "AboutTextPopUP";
			info.notClickable = 1;
			info.isTitle = 0;
			UIDropDownMenu_AddButton(info, UIDROPDOWNMENU_MENU_LEVEL);
		end

		return;
	end
		
	TitanPanelRightClickMenu_AddTitle(TitanPlugins[TITAN_ORE_ID].menuText);

	-- Show Skills
	info = {};
	info.text = TITAN_ORE_LOCAL_SHOW_SKILLS;
	info.func = TitanPanelOreButton_ToggleShowSkills;
	info.checked = TitanUtils_Toggle(TitanGetVar(TITAN_ORE_ID, "ShowSkills"));
	info.keepShownOnClick = 1;
	UIDropDownMenu_AddButton(info);
	
	-- Show Secondary Skills
	info = {};
	info.text = TITAN_ORE_LOCAL_SHOW_SEC_SKILLS;
	info.func = TitanPanelOreButton_ToggleShowSecSkills;
	info.checked = TitanUtils_Toggle(TitanGetVar(TITAN_ORE_ID, "ShowSecSkills"));
	info.keepShownOnClick = 1;
	UIDropDownMenu_AddButton(info);

	-- Hidde zero option
	info = {};
	info.text = TITAN_ORE_LOCAL_HIDDE_ZERO;
	info.func = TitanPanelOreButton_ToggleShowZerro;
	info.checked = TitanUtils_Toggle(TitanGetVar(TITAN_ORE_ID, "ShowZerro"));
	info.keepShownOnClick = 1;
	UIDropDownMenu_AddButton(info);

	-- Show Info Tooltip
	info = {};
	info.text = TITAN_ORE_LOCAL_SHOW_TOOLTIP;
	info.func = TitanPanelOreButton_ToggleShowInfoTooltip;
	info.checked = TitanUtils_Toggle(TitanGetVar(TITAN_ORE_ID, "ShowInfoTooltip"));
	info.keepShownOnClick = 1;
	UIDropDownMenu_AddButton(info);
	
	-- Debug mode
	info = {};
	info.text = TITAN_ORE_LOCAL_DEBUG_MODE;
	info.func = TitanPanelOreButton_ToggleDebugmode;
	info.checked = TitanUtils_Toggle(TitanGetVar(TITAN_ORE_ID, "Debugmode"));
	info.keepShownOnClick = 1;
	UIDropDownMenu_AddButton(info);

	-- bank items
	info = {};
	info.text = TITAN_ORE_LOCAL_BANK_ITEMS;
	info.value = TITAN_ORE_LOCAL_BANK_ITEMS;
	info.hasArrow = 1;
	UIDropDownMenu_AddButton(info);

	TitanPanelRightClickMenu_AddSpacer();

	-- categories label
	info = {};
	info.text = TITAN_ORE_LOCAL_SHOW_CATEGORIES;
	info.isTitle = 1;
	UIDropDownMenu_AddButton(info);

	-- Show Ore in tooltip
	info = {};
	info.text = TITAN_ORE_LOCAL_SHOW_ORE;
	info.func = TitanPanelOreButton_ToggleShowOre;
	info.checked = TitanUtils_Toggle(TitanGetVar(TITAN_ORE_ID, "ShowOre"));
	info.keepShownOnClick = 1;
	UIDropDownMenu_AddButton(info);

	-- Show Bar in tooltip
	info = {};
	info.text = TITAN_ORE_LOCAL_SHOW_BAR;
	info.func = TitanPanelOreButton_ToggleShowBar;
	info.checked = TitanUtils_Toggle(TitanGetVar(TITAN_ORE_ID, "ShowBar"));
	info.keepShownOnClick = 1;
	UIDropDownMenu_AddButton(info);

	-- Show Stone in tooltip
	info = {};
	info.text = TITAN_ORE_LOCAL_SHOW_STONE;
	info.func = TitanPanelOreButton_ToggleShowStone;
	info.checked = TitanUtils_Toggle(TitanGetVar(TITAN_ORE_ID, "ShowStone"));
	info.keepShownOnClick = 1;
	UIDropDownMenu_AddButton(info);

	-- Show Gem in tooltip
	info = {};
	info.text = TITAN_ORE_LOCAL_SHOW_GEM;
	info.func = TitanPanelOreButton_ToggleShowGem;
	info.checked = TitanUtils_Toggle(TitanGetVar(TITAN_ORE_ID, "ShowGem"));
	info.keepShownOnClick = 1;
	UIDropDownMenu_AddButton(info);

	-- Show Leather in tooltip
	info = {};
	info.text = TITAN_ORE_LOCAL_SHOW_LEATHER;
	info.func = TitanPanelOreButton_ToggleShowLeather;
	info.checked = TitanUtils_Toggle(TitanGetVar(TITAN_ORE_ID, "ShowLeather"));
	info.keepShownOnClick = 1;
	UIDropDownMenu_AddButton(info);

	-- Show Scales in tooltip
	info = {};
	info.text = TITAN_ORE_LOCAL_SHOW_SCALE;
	info.func = TitanPanelOreButton_ToggleShowScale;
	info.checked = TitanUtils_Toggle(TitanGetVar(TITAN_ORE_ID, "ShowScale"));
	info.keepShownOnClick = 1;
	UIDropDownMenu_AddButton(info);

	-- Show Hide in tooltip
	info = {};
	info.text = TITAN_ORE_LOCAL_SHOW_HIDE;
	info.func = TitanPanelOreButton_ToggleShowHide;
	info.checked = TitanUtils_Toggle(TitanGetVar(TITAN_ORE_ID, "ShowHide"));
	info.keepShownOnClick = 1;
	UIDropDownMenu_AddButton(info);

	-- Show Cloths in tooltip
	info = {};
	info.text = TITAN_ORE_LOCAL_SHOW_CLOTH;
	info.func = TitanPanelOreButton_ToggleShowCloth;
	info.checked = TitanUtils_Toggle(TitanGetVar(TITAN_ORE_ID, "ShowCloth"));
	info.keepShownOnClick = 1;
	UIDropDownMenu_AddButton(info);
	
	-- Show Herbs in tooltip
	info = {};
	info.text = TITAN_ORE_LOCAL_SHOW_HERB;
	info.func = TitanPanelOreButton_ToggleShowHerb;
	info.checked = TitanUtils_Toggle(TitanGetVar(TITAN_ORE_ID, "ShowHerb"));
	info.keepShownOnClick = 1;
	UIDropDownMenu_AddButton(info);

	-- Show Essence in tooltip
	TITAN_ORE_TOGGLE_SHOW = "ShowEssence";
	info = {};
	info.text = TITAN_ORE_LOCAL_SHOW_ESSENCE;
	info.func = TitanPanelOreButton_ToggleShowEssence;
	info.checked = TitanUtils_Toggle(TitanGetVar(TITAN_ORE_ID, "ShowEssence"));
	info.keepShownOnClick = 1;
	UIDropDownMenu_AddButton(info);

	-- Show Misc in tooltip
	TITAN_ORE_TOGGLE_SHOW = "ShowMisc";
	info = {};
	info.text = TITAN_ORE_LOCAL_SHOW_MISC;
	info.func = TitanPanelOreButton_ToggleShowMisc;
	info.checked = TitanUtils_Toggle(TitanGetVar(TITAN_ORE_ID, "ShowMisc"));
	info.keepShownOnClick = 1;
	UIDropDownMenu_AddButton(info);

	-- Show Bandages in tooltip
	TITAN_ORE_TOGGLE_SHOW = "ShowBandage";
	info = {};
	info.text = TITAN_ORE_LOCAL_SHOW_BANDAGE;
	info.func = TitanPanelOreButton_ToggleShowBandage;
	info.checked = TitanUtils_Toggle(TitanGetVar(TITAN_ORE_ID, "ShowBandage"));
	info.keepShownOnClick = 1;
	UIDropDownMenu_AddButton(info);

	-- Show Poisons in tooltip
	TITAN_ORE_TOGGLE_SHOW = "ShowPoison";
	info = {};
	info.text = TITAN_ORE_LOCAL_SHOW_POISON;
	info.func = TitanPanelOreButton_ToggleShowPoison;
	info.checked = TitanUtils_Toggle(TitanGetVar(TITAN_ORE_ID, "ShowPoison"));
	info.keepShownOnClick = 1;
	UIDropDownMenu_AddButton(info);

	-- Show Poisons Mats in tooltip
	TITAN_ORE_TOGGLE_SHOW = "ShowPmat";
	info = {};
	info.text = TITAN_ORE_LOCAL_SHOW_PMAT;
	info.func = TitanPanelOreButton_ToggleShowPmat;
	info.checked = TitanUtils_Toggle(TitanGetVar(TITAN_ORE_ID, "ShowPmat"));
	info.keepShownOnClick = 1;
	UIDropDownMenu_AddButton(info);

	-- Show Inscriptions Inks in tooltip
	TITAN_ORE_TOGGLE_SHOW = "ShowInscriptInk";
	info = {};
	info.text = TITAN_ORE_LOCAL_SHOW_INSC_INK;
	info.func = TitanPanelOreButton_ToggleShowInscriptionsInk;
	info.checked = TitanUtils_Toggle(TitanGetVar(TITAN_ORE_ID, "ShowInscriptInk"));
	info.keepShownOnClick = 1;
	UIDropDownMenu_AddButton(info);

	-- Show Inscriptions Pigments in tooltip
	TITAN_ORE_TOGGLE_SHOW = "ShowInscriptPigment";
	info = {};
	info.text = TITAN_ORE_LOCAL_SHOW_INSC_PIG;
	info.func = TitanPanelOreButton_ToggleShowInscriptionsPigment;
	info.checked = TitanUtils_Toggle(TitanGetVar(TITAN_ORE_ID, "ShowInscriptPigment"));
	info.keepShownOnClick = 1;
	UIDropDownMenu_AddButton(info);

	-- Show Cooking mats in tooltip
	info = {};
	info.text = TITAN_ORE_LOCAL_SHOW_COOKING;
	info.func = TitanPanelOreButton_ToggleShowCooking;
	info.checked = TitanUtils_Toggle(TitanGetVar(TITAN_ORE_ID, "ShowCooking"));
	info.keepShownOnClick = 1;
	UIDropDownMenu_AddButton(info);

	TitanPanelRightClickMenu_AddSpacer();
	
	if (TITAN_ORE_PLAYER_CLASS == "WARLOCK") then
		-- Shards submenu
		info = {};
		info.text = TITAN_ORE_LOCAL_SHARDS;
		info.value = TITAN_ORE_LOCAL_SHARDS;
		info.hasArrow = 1;
		UIDropDownMenu_AddButton(info);
	end

	-- titan panel options
	info = {};
	info.text = TITAN_ORE_LOCAL_SHOW_TITAN_OPT;
	info.isTitle = 1;
	UIDropDownMenu_AddButton(info);

	TitanPanelRightClickMenu_AddToggleIcon(TITAN_ORE_ID);
	TitanPanelRightClickMenu_AddToggleLabelText(TITAN_ORE_ID);
	--TitanPanelRightClickMenu_AddToggleColoredText(TITAN_ORE_ID);
	TitanPanelRightClickMenu_AddCommand(TITAN_PANEL_MENU_HIDE, TITAN_ORE_ID, TITAN_PANEL_MENU_FUNC_HIDE);

	-- info about plugin
	info = {};
	info.text = TITAN_ORE_ABOUT_TEXT;
	info.value = "DisplayAbout";
	info.hasArrow = 1;
	UIDropDownMenu_AddButton(info);

end

function TitanPanelOre_SetDisplay(self)
	local db = TitanGetVar(TITAN_ORE_ID, "displayitems");
	local i,d,found;
	if(self.value == 0) then
		TitanSetVar(TITAN_ORE_ID, "displayitems", {});
	else
		found = 0;
		for i,d in pairs(db) do
			if(d == self.value)then
				found = i;
			end
		end
		if(found > 0) then
			table.remove(db,found)
		else
			while(table.getn(db)>80) do
				table.remove(db);
			end;
			table.insert(db,self.value);
		end
		TitanSetVar(TITAN_ORE_ID, "displayitems", db);
	end;
	TitanPanelButton_UpdateButton(TITAN_ORE_ID);
end

function TitanPanelOreButton_isdisp(val)
	local disp = TitanGetVar(TITAN_ORE_ID, "displayitems");
	local i,d;
	
	if(type(disp) ~= "table") then
		return 0;
	end
	
	for i,d in pairs(disp) do
		if(d==val) then
			return 1;
		end
	end
	return nil;
end

function TitanPanelOreButton_ToggleShowInfoTooltip()
	TitanToggleVar(TITAN_ORE_ID, "ShowInfoTooltip");
	TitanPanelButton_UpdateButton(TITAN_ORE_ID);
end

function TitanPanelOreButton_ToggleDebugmode()
	TitanToggleVar(TITAN_ORE_ID, "Debugmode");
	TitanPanelButton_UpdateButton(TITAN_ORE_ID);
end

function TitanPanelOreButton_ToggleEcludeZero()
	TitanToggleVar(TITAN_ORE_ID, "ExcludeZero");
	TitanPanelButton_UpdateButton(TITAN_ORE_ID);
end

function TitanPanelOreButton_ToggleShowZerro()
	TitanToggleVar(TITAN_ORE_ID, "ShowZerro");
	TitanPanelButton_UpdateButton(TITAN_ORE_ID);
end

function TitanPanelOreButton_ToggleShowSkills()
	TitanToggleVar(TITAN_ORE_ID, "ShowSkills");
	TitanPanelButton_UpdateButton(TITAN_ORE_ID);
end

function TitanPanelOreButton_ToggleShowSecSkills()
	TitanToggleVar(TITAN_ORE_ID, "ShowSecSkills");
	TitanPanelButton_UpdateButton(TITAN_ORE_ID);
end

function TitanPanelOreButton_ToggleShowOre()
	TitanToggleVar(TITAN_ORE_ID, "ShowOre");
	TitanPanelButton_UpdateButton(TITAN_ORE_ID);
end

function TitanPanelOreButton_ToggleShowBar()
	TitanToggleVar(TITAN_ORE_ID, "ShowBar");
	TitanPanelButton_UpdateButton(TITAN_ORE_ID);
end

function TitanPanelOreButton_ToggleShowStone()
	TitanToggleVar(TITAN_ORE_ID, "ShowStone");
	TitanPanelButton_UpdateButton(TITAN_ORE_ID);
end

function TitanPanelOreButton_ToggleShowGem()
	TitanToggleVar(TITAN_ORE_ID, "ShowGem");
	TitanPanelButton_UpdateButton(TITAN_ORE_ID);
end

function TitanPanelOreButton_ToggleShowLeather()
	TitanToggleVar(TITAN_ORE_ID, "ShowLeather");
	TitanPanelButton_UpdateButton(TITAN_ORE_ID);
end

function TitanPanelOreButton_ToggleShowScale()
	TitanToggleVar(TITAN_ORE_ID, "ShowScale");
	TitanPanelButton_UpdateButton(TITAN_ORE_ID);
end

function TitanPanelOreButton_ToggleShowHide()
	TitanToggleVar(TITAN_ORE_ID, "ShowHide");
	TitanPanelButton_UpdateButton(TITAN_ORE_ID);
end

function TitanPanelOreButton_ToggleShowHerb()
	TitanToggleVar(TITAN_ORE_ID, "ShowHerb");
	TitanPanelButton_UpdateButton(TITAN_ORE_ID);
end

function TitanPanelOreButton_ToggleShowCloth()
	TitanToggleVar(TITAN_ORE_ID, "ShowCloth");
	TitanPanelButton_UpdateButton(TITAN_ORE_ID);
end

function TitanPanelOreButton_ToggleShowEssence()
	TitanToggleVar(TITAN_ORE_ID, "ShowEssence");
	TitanPanelButton_UpdateButton(TITAN_ORE_ID);
end

function TitanPanelOreButton_ToggleShowBankItems()
	TitanToggleVar(TITAN_ORE_ID, "ShowBankItems");
	TitanPanelButton_UpdateButton(TITAN_ORE_ID);
end

function TitanPanelOreButton_ToggleShowMisc()
	TitanToggleVar(TITAN_ORE_ID, "ShowMisc");
	TitanPanelButton_UpdateButton(TITAN_ORE_ID);
end

function TitanPanelOreButton_ToggleShowBandage()
	TitanToggleVar(TITAN_ORE_ID, "ShowBandage");
	TitanPanelButton_UpdateButton(TITAN_ORE_ID);
end

function TitanPanelOreButton_ToggleShowPoison()
	TitanToggleVar(TITAN_ORE_ID, "ShowPoison");
	TitanPanelButton_UpdateButton(TITAN_ORE_ID);
end

function TitanPanelOreButton_ToggleShowPmat()
	TitanToggleVar(TITAN_ORE_ID, "ShowPmat");
	TitanPanelButton_UpdateButton(TITAN_ORE_ID);
end

function TitanPanelOreButton_ToggleShowInscriptionsInk()
	TitanToggleVar(TITAN_ORE_ID, "ShowInscriptInk");
	TitanPanelButton_UpdateButton(TITAN_ORE_ID);
end

function TitanPanelOreButton_ToggleShowInscriptionsPigment()
	TitanToggleVar(TITAN_ORE_ID, "ShowInscriptPigment");
	TitanPanelButton_UpdateButton(TITAN_ORE_ID);
end

function TitanPanelOreButton_ToggleShowCooking()
	TitanToggleVar(TITAN_ORE_ID, "ShowCooking");
	TitanPanelButton_UpdateButton(TITAN_ORE_ID);
end

function TitanPanelOre_GetSkillLevel(skilltype)
    local numskills = GetNumSkillLines();
    for i=1,numskills do
        local skillname, _, _, skillrank,_,_,skillmax = GetSkillLineInfo(i);
        
        if (skillname == "Mining" and skilltype == "Mining") then
        	return skillrank;
		elseif (skillname == "Herbalism" and skilltype == "Herbalism") then
          	return skillrank;
		elseif (skillname == "Skinning" and skilltype == "Skinning") then
        	return skillrank;
		elseif (skillname == "Alchemy" and skilltype == "Alchemy") then
        	return skillrank;     
		elseif (skillname == "Enchanting" and skilltype == "Enchanting") then
        	return skillrank;
		elseif (skillname == "First Aid" and skilltype == "First Aid") then
        	return skillrank;
		elseif (skillname == "Poisons" and skilltype == "Poisons") then
        	return skillrank;
		elseif (skillname == "Inscription" and skilltype == "Inscription") then
        	return skillrank;
		elseif (skillname == "Cooking" and skilltype == "Cooking") then
        	return skillrank;
        end     
    end
    return 0;
end

function TitanPanelOre_GetSkillRankColor(skill,skillmax)

	local color = TITAN_ORE_RED;
	
	TITAN_SKILLS_PERCENT = floor( ( (skill) / skillmax ) * 100 );

	if ( TITAN_SKILLS_PERCENT > 49) then
		color = TITAN_ORE_ORANGE;
	end
	if ( TITAN_SKILLS_PERCENT > 74 ) then
		color = TITAN_ORE_YELLOW;
	end
	if ( TITAN_SKILLS_PERCENT > 94) then
		color = TITAN_ORE_GREEN;
	end
	
	return color;	
end

function TitanPanelOre_GetSkilColor(skillreq,skill)
	
	local color = TITAN_ORE_RED;

	if (skillreq == -1) then
		return TITAN_ORE_GREEN;
	end
	
	if ( not skill or skill == 0) then
		return TITAN_ORE_RED; 
	end	

	if (skillreq > skill) then
		color = TITAN_ORE_RED;
	else
		color = TITAN_ORE_ORANGE;

		if (skillreq + 24 < skill) then
			color = TITAN_ORE_GOLD;
		end
		if (skillreq + 49 < skill) then
			color = TITAN_ORE_YELLOW;
		end
		if (skillreq + 74 < skill) then
			color = TITAN_ORE_GREEN;
		end
	end
	return color;
end

-------------------------------------------------------
-- TitanPanelOre_loot
-- On event LOOT_OPENED will stored all looted items
-------------------------------------------------------

function TitanPanelOre_loot()
	
	for index = 1, GetNumLootItems(), 1 do
		if (LootSlotIsItem(index)) then
	    	local texture, fishie, quantity, quality = GetLootSlotInfo(index);
	    	local link = GetLootSlotLink(index);
			local _,_, color, id, name = string.find(link, "|c(%x+)|Hitem:(%d+):[%d:]+|h%[(.-)%]|h|r");
			TitanPanelOre_updateHistory(name, quantity,link);
	 	end
	end
	
end

-------------------------------------------------------
-- TitanPanelOre_bankOpen()
-- On event BANKFRAME_OPEN will cleared all data in db
-------------------------------------------------------
function TitanPanelOre_bankOpen()
	TITAN_ORE_EV = 0;
end

-------------------------------------------------------
-- TitanPanelOre_bankClose()
-- On event BANKFRAME_CLOSE will stored data to db
-------------------------------------------------------
function TitanPanelOre_bankClose()
if (TITAN_ORE_EV == 1) then
	return;
else

	
	local dbb = {};
	
	if GetNumBankSlots() then
		maxBslot, _ = GetNumBankSlots();
	else
		maxBslot = 0;
	end
		local nbslots, b, s, t, n, nn;
		local i_count = 0;

			nbanka=GetContainerNumSlots(-1);
			TitanPanelOre_PrintDebug("bank ------>");
			for s=0, nbanka do
				local texture, itemCount = GetContainerItemInfo(-1, s);
				iName = GetContainerItemLink(-1, s);
				if (iName) then
					nitem = { name = iName, value = itemCount };
					table.insert(dbb,nitem);
					TitanPanelOre_PrintDebug(iName.." added: "..itemCount.." stack.");
				end
			end

	if (maxBslot >0) then
			TitanPanelOre_PrintDebug("bags in bank ------>");
		for b=1, maxBslot, 1 do
			ibag = b+4;
			nbslots=GetContainerNumSlots(ibag);
			
			for s=1,nbslots do
				local texture, itemCount = GetContainerItemInfo(ibag, s);
				iName = GetContainerItemLink(ibag, s);
				if (iName) then
					nitem = { name = iName, value = itemCount };
					table.insert(dbb,nitem);
					TitanPanelOre_PrintDebug(iName.." added: "..itemCount.." stack.");
				end
			end
		end
	end
TITAN_ORE_EV = 1;

	echo(TITAN_ORE_GREEN.."Titan Gathered: "..TITAN_ORE_YELLOW.."bank database updated..");
	TitanSetVar(TITAN_ORE_ID, "bankHistory", dbb);
end
end

function TitanPanelOre_addNewClearItem(name)
	local cdb = TitanGetVar(TITAN_ORE_ID, "clearItems");

	table.insert(cdb,name);
end
-------------------------------------------------------
-- TitaTitanPanelOre_updateHistory(item as string,iQuantity as number)
-- Update item history in database
-------------------------------------------------------
function TitanPanelOre_updateHistory(item,iQuantity,link)
	local db = TitanGetVar(TITAN_ORE_ID, "itemsHistory");
	local i,d,v,r,found;
	local nitem = {};
	local fnd = 0;
	local fndSUM = 0;
	local fndH = 0;
    local fndBags = 0;
    local fndBank = 0;
	
	found = 0;
	for i,d in pairs(db) do
		if (type(d) == "table")then
			if(d.name == item)then
				r = d.value;
				found = i;
			end
		end
	end
	
	fnd = TitanPanelOre_IsExistMat(item);
	
	if(found > 0) then
		local oldValue = 0;
		local newValue = 0;
		
		oldValue = r;
		newValue = oldValue + iQuantity;
		
		if (fnd > 0) then
    		fndBags = GetItemsFromBags(item);
	   	    fndBank = GetItemsFromBank(item);
	        fndH 	= GetItemsFromHistory(item);
	        fndSUM  = ((fndBags + iQuantity) + fndBank)*1;
			nitem = { name = item, value = newValue};
		    table.remove(db, found);
			table.insert(db,found,nitem);

			TitanPanelOre_PrintDebug("|cffffff20TG item found: |cffff00ff"..iQuantity.."x "..link.." |cffffff20Bags: |cffff00ff"..fndBags + iQuantity.." |cffffff20Bank: |cffff00ff"..fndBank.." |cffffff20Sum: |cffff00ff"..fndSUM);
		end
	else
		if (fnd > 0) then
			nitem = { name = item, value = iQuantity};
			table.insert(db,nitem);
			TitanPanelOre_PrintDebug("|cffffff20TG item found: |cffff00ff"..iQuantity.."x "..link.." |cffffff20Bags: |cffff00ff"..fndBags + iQuantity.." |cffffff20Bank: |cffff00ff"..fndBank.." |cffffff20Sum: |cffff00ff"..fndSUM);
--			TitanPanelOre_PrintDebug("Titan Ore history: "..TITAN_ORE_GREEN..item..TITAN_ORE_YELLOW.." inserted to db.");
		end
	end
	TitanSetVar(TITAN_ORE_ID, "itemsHistory", db);
end

-------------------------------------------------------
-- TitanPanelOre_ShowHistory()
-- Show trade items history in default log
-------------------------------------------------------
function TitanPanelOre_ShowHistory()
	local db = TitanGetVar(TITAN_ORE_ID, "itemsHistory");

	local i,d;
	local fnd = 0;
	found = 0;

	echo(TITAN_ORE_YELLOW.." ");
	echo(TITAN_ORE_YELLOW.."------------------------------------------");
	echo(TITAN_ORE_YELLOW.."Titan Ore "..TITAN_ORE_GREEN..TITAN_ORE_VERSION..TITAN_ORE_YELLOW.." history statistic:");
	echo(TITAN_ORE_YELLOW.."------------------------------------------");

	if (db) then
		for i,e in pairs(db) do
			if (type(e) == "table") then
				fnd = TitanPanelOre_IsExistMat(e.name);
				if (fnd > 0) then
					echo(e.name..": "..TITAN_ORE_GREEN..e.value);
				end
			end
		end
	end

	echo(TITAN_ORE_YELLOW.."--- end list -----------------------------");
end

-------------------------------------------------------
-- TitanPanelOre_ShowBank()
-- Show items stored at bank in default log
-------------------------------------------------------
function TitanPanelOre_ShowBank()
	local dbb = TitanGetVar(TITAN_ORE_ID, "bankHistory");
	local i,e;

	echo(TITAN_ORE_YELLOW.." ");
	echo(TITAN_ORE_YELLOW.."------------------------------------------------");
	echo(TITAN_ORE_YELLOW.."Titan Ore "..TITAN_ORE_GREEN..TITAN_ORE_VERSION..TITAN_ORE_YELLOW.." bank items:");
	echo(TITAN_ORE_YELLOW.."------------------------------------------------");

	if (dbb) then
		for i,e in pairs(dbb) do
			if (type(e) == "table") then
				echo(e.name..": "..TITAN_ORE_GREEN..e.value);
			end
		end
	end

	echo(TITAN_ORE_YELLOW.."--- end list -----------------------------");
end

-------------------------------------------------------
-- TitanPanelOre_IsExistMat()
-- Check if materil is member of tradeskil mats
-------------------------------------------------------
function TitanPanelOre_IsExistMat(item)
	local i,iname;
	local f = 0;

	for i,iname in pairs(TITAN_ORE_ITEMS) do
		if (item == iname.name) then
			if (iname.cat == TITAN_ORE_LOCAL_ORES) then
				return i;
			end
			if (iname.cat == TITAN_ORE_LOCAL_BARS) then
				return i;
			end
			if (iname.cat == TITAN_ORE_LOCAL_STONES) then
				return i;
			end
			if (iname.cat == TITAN_ORE_LOCAL_GEMS) then
				return i;
			end
			if (iname.cat == TITAN_ORE_LOCAL_SHARDS) then
				return i;
			end
			if (iname.cat == TITAN_ORE_LOCAL_LEATHERS) then
				return i;
			end
			if (iname.cat == TITAN_ORE_LOCAL_SCALES) then
				return i;
			end
			if (iname.cat == TITAN_ORE_LOCAL_CLOTHS) then
				return i;
			end
			if (iname.cat == TITAN_ORE_LOCAL_HIDES) then
				return i;
			end
			if (iname.cat == TITAN_ORE_LOCAL_HERBS) then
				return i;
			end
			if (iname.cat == TITAN_ORE_LOCAL_ESSENCES) then
				return i;
			end
			if (iname.cat == TITAN_ORE_LOCAL_MISC) then
				return i;
			end
			if (iname.cat == TITAN_ORE_LOCAL_BANDAGES) then
				return i;
			end
			if (iname.cat == TITAN_ORE_LOCAL_POISONS) then
				return i;
			end
			if (iname.cat == TITAN_ORE_LOCAL_PMATS) then
				return i;
			end
			if (iname.cat == TITAN_ORE_LOCAL_INSCRIPT_INK) then
				return i;
			end
			if (iname.cat == TITAN_ORE_LOCAL_INSCRIPT_PIG) then
				return i;
			end
			if (iname.cat == TITAN_ORE_LOCAL_COOKINGS) then
				return i;
			end
		end
	end
	return 0;
end

-------------------------------------------------------
-- TitanPanelOre_IsExistMat()
-- Check if materil is member of tradeskil mats
-------------------------------------------------------
function TitanPanelOre_GetCategory(item)
	local i,iname;
	local f = 0;

	for i,iname in pairs(TITAN_ORE_ITEMS) do
		if (item == iname.name) then
			return iname.cat;
		end
	end
	return 0;
end

-------------------------------------------------------
-- TitanPanelOre_IsExistMat()
-- Check if materil is member of tradeskil mats
-------------------------------------------------------
function TitanPanelOre_GetCategorySkill(tag)
	local i,iname;
	local f = 0;

	for i,iname in pairs(TITAN_ORE_CATEGORIES) do

		if (tag == iname.tag) then
			return iname.skillneed;
		end
	end
	return 0;
end

-------------------------------------------------------
-- TitanPanelOre_IsExistMat()
-- Check if materil is member of tradeskil mats
-------------------------------------------------------
function TitanPanelOre_GetSkill(item)
	local i,iname;
	local f = 0;

	for i,iname in pairs(TITAN_ORE_ITEMS) do
		if (item == iname.name) then
			return iname.skill;
		end
	end
	return 0;
end

function TitanPanelOre_PrintInfo()

	echo("");
	echo(TITAN_ORE_YELLOW.."------------------------------------------------");
	echo(TITAN_ORE_YELLOW..TITAN_ORE_LOCAL_NAME.." "..TITAN_ORE_VERSION..TITAN_ORE_GREEN.." By Medyn");
	echo(TITAN_ORE_YELLOW.."------------------------------------------------");
	echo("|cf0063000/to /tohelp - print this info");
	echo("/mh /mathistory - print history result");
	echo("/tob /tobank - print materil stored in bank");

end

function TitanPanelOre_PrintDebug(text)
    if ( not TitanGetVar(TITAN_ORE_ID, "Debugmode")) then 
		DEFAULT_CHAT_FRAME:AddMessage(TITAN_ORE_YELLOW..text);
	end
end

function echo(text)
	if (text) then DEFAULT_CHAT_FRAME:AddMessage(TITAN_ORE_YELLOW..text); end
end

function CheckIfItemIsGathered(item)
	local i,iname;
	local f = 0;

	for i,iname in pairs(TITAN_ORE_ITEMS) do
		if (item == iname.name) then
			return 1;
		end
	end
	return 0;
end

function GetItemsFromBank(item)
	local dbb = TitanGetVar(TITAN_ORE_ID, "bankHistory");
	local i,e;
	local eName;
	local i_count = 0;
	
	if (dbb) then
		for i,e in pairs(dbb) do
			if (type(e) == "table") then
				local bName = GetItemInfo(e.name);

				if (bName == item) then
					i_count = i_count + e.value;
				end
			end
		end
	end
	
	return i_count;
end

function GetItemsFromHistory(item)
	local dbb = TitanGetVar(TITAN_ORE_ID, "itemsHistory");
	local i,e;
	local i_count = 0;
	
	if (dbb) then
		for i,e in pairs(dbb) do
			if (type(e) == "table") then
				if (e.name == item) then
					i_count = i_count + e.value;
				end
			end
		end
	end
	
	return i_count;
end

function GetItemsFromBags(item)
	local nbslots, b, s, t, n;
	local i_count = 0;
		
		for b=0,4 do
			nbslots=GetContainerNumSlots(b);
			for s=0,nbslots do
				local texture, itemCount = GetContainerItemInfo(b, s);

				t = GetContainerItemLink(b, s);
		
				if (t) then

					local bName = GetItemInfo(t);
					
					if (bName == item) then
						i_count = i_count + itemCount;
						
					end
				end
			end
		end
	return i_count;
end

function TitanPanelOreShowTooltip(item)

    if ( TitanGetVar(TITAN_ORE_ID, "ShowInfoTooltip")) then return; end
	local lbl = getglobal("GameTooltipTextLeft1");
 	local itemName = lbl:GetText();
 	local no = getglobal(item);
 	
	--local sName, sLink, iRarity, iLevel, iMinLevel, sType, sSubType, iStackCount = GetItemInfo(16846);

	fndBags = 0;
	fndBank = 0;
	fndH 	= 0;

	local skillInfo = "";
	local skill_color = TITAN_ORE_RED;

    local fndSkill      = TitanPanelOre_GetSkill(itemName);
    local fndCat        = TitanPanelOre_GetCategory(itemName);
    local fndReqSkill   = TitanPanelOre_GetCategorySkill(fndCat);
    local numskills     = GetNumSkillLines();
	    
    for i=1,numskills do
	        
    	local skillname, isHeader, _, skillrank,_,_,skillmax = GetSkillLineInfo(i);
        if ( skillname == fndReqSkill) then
			skill_color = TitanPanelOre_GetSkilColor(fndSkill,skillrank);
        end
    end

	
	if (CheckIfItemIsGathered(itemName) == 1) then
 	
		fndBags  = GetItemsFromBags(itemName);
		fndBank  = GetItemsFromBank(itemName);
		fndH 	 = GetItemsFromHistory(itemName);

	    if (fndSkill > 0) then
	       skillInfo = "|cffffff20Required Skill: |r"..fndReqSkill.." "..skill_color..fndSkill;
	    end
	    
		GameTooltip:AddLine(skillInfo, 0, 50, 255);
		GameTooltip:AddLine("|cffffff20Sum:|cffff00ff "..fndBags+fndBank.."|cffffff20 Bags: |cffff00ff"..fndBags.."|cffffff20 Bank: |cffff00ff"..fndBank.."|r", 0, 50, 255);
	
		GameTooltip:Show();
	end
end

function TitanPanelOre_addLootItem(item)
	
	local db = TitanGetVar(TITAN_ORE_ID, "clearItems");
	local i,d,v,r,found;
	local nitem = {};
	
	found = 0;
	for i,d in pairs(db) do
		if (type(d) == "table")then
			if(d.name == item)then
				r = d.value;
				found = i;
			end
		end
	end
	
	if(found > 0) then
	   echo(item.." allready exist in database!");
	else
		nitem = { name = item, value = 0};
	    echo(item.." added..");
	end
	
end
